package com.jiuqi.util.patterns;

import java.util.Map;

interface IPattern {
   int CONST = 0;
   int VARIABLE = 1;
   int PLACEHODER = 2;

   int getType();

   int size();

   IPattern get(int var1);

   void add(IPattern var1);

   void add(int var1, IPattern var2);

   void remove(int var1);

   int indexOf(IPattern var1);

   void clear();

   String getExpression();

   void setExpression(String var1);

   int getLength();

   void setLength(int var1);

   int match(String var1, int var2, Map var3);

   String replace(ITranslator var1);
}
